BEGIN   EQU #8000

        ORG #6000
        CALL INSTC
        RET

INSTC   DI
        IN (#FA)
        LD HL,BEGIN
        LD DE,0
        LD BC,#4000
        LDIR
        IN (#7B)
        EI
        RET

        ORG 0,BEGIN
        JP R00H
        DS 5
        JP R08H
        DS 5
        JP R10H
        DS 5
        JP R18H
        DS 5
        JP R20H
        DS 5
        JP R28H
        DS 5
        JP R30H
        DS 5
        JP R38H
        DS 5

IDENT   DB "Shadow RAM BIOS v1.0    "
        DS #0E

        JP NMI

        ORG #0070,BEGIN+#0070
PGMAX   DB #3F
PGCURR  DB 0
KBDREG  DB 0
KBDDEL  DB 0
KBDREP  DB 0
KBDLST  DB 0
SCCLST  DW 0
PRXY    DW 0
PRAT    DB 0
FDDST   DW 0
FDDERR  DB 0
FDDN    DB 0
FDDTS   DW 0
FDDAD1  DW 0
FDDAD2  DW 0
FDDSEC  DB 0

        ORG #0200,BEGIN+#0200
        JP HIMEM
        JP RCMOS
        JP WCMOS
        JP INKEY
        JP INSCC
        JP SCC
        JP PRSYM
        JP PRATR
        JP PRLS
        JP PRLA
        JP SETXY
        JP SETAT

        ORG #0800,BEGIN+#0800
HIMEM   LD (PGCURR),A
        PUSH BC,AF
.3      RRA
        AND #07
        LD BC,#DFFD
        OUT A
        POP AF
        AND #07
        OR #10
        LD B,#7F
        OUT A
        POP BC
        RET

FDD     LD A,C
        CP #08
        RET NC
        PUSH HL,BC
        LD HL,FDDPR
        LD B,0
        SLA C
        ADD HL,BC
        POP BC
        LD A,(HL)
        INC HL
        LD H,(HL)
        EX (SP),HL
        RET

FDDRES  IN (#F8)
        LD A,(FDDN)
        ADD A,#3C
        OUT (#FF)
        LD A,#08
        OUT (#1F)
FDDRES1 IN (#FF)
        RLA
        JR NC,FDDRES1
        IN (#FA)
        RET

FDDSET  LD A,B
        AND #03
        LD (FDDN),A
        JR FDDRES

FDDPOS  IN (#F8)
        LD A,B
        LD (FDDTS+1),A
        SRL B
        LD C,#3C
        JR NC,FDDPOS1
        LD C,#2C
FDDPOS1 LD A,(FDDN)
        OR C
        OUT (#FF)
        IN (#7F)
        CP B
        PUSH AF
        LD A,#18
        OUT (#1F)
FDDPOS2 IN (#FF)
        RLA
        JR NC,FDDPOS2
        POP AF
        CALL NZ,FDDPOS3
        LD A,B
        OUT (#3F)
        IN (#F8)
        RET
FDDPOS3 LD A,#10

FDDPAU  LD C,0
FDDPAU1 DEC C
        JR NZ,FDDPAU1
        DEC A
        JR NZ,FDDPAU
        RET

FDDR    PUSH HL
        LD HL,FDDRS
        LD (FDDS1+1),HL
        POP HL
        JR FDDS

FDDW    PUSH HL
        LD HL,FDDWS
        LD (FDDS1+1),HL
        POP HL

FDDS    LD C,3
        LD (FDDAD1),HL
        LD (FDDTS),DE
        LD A,B
        LD (FDDSEC),A
FDDS1   CALL 0
        LD (FDDAD2),HL
        LD A,(FDDST+1)
        AND A
        JP Z,FDDE
        LD A,(FDDST)
        AND A
        JP NZ,FDDE
FDDS2   INC E
        BIT 4,E
        RES 4,E
        JR Z,FDDS3
        INC D
FDDS3   DJNZ FDDS
        XOR A
        LD (FDDERR),A
        RET

FDDRET  LD A,(FDDERR)
        AND A
        RET Z
        LD HL,(FDDAD1)
        LD DE,(FDDTS)
        LD A,(FDDSEC)
        LD B,A
        JP FDDS

FDDIGN  LD A,(FDDERR)
        AND A
        RET Z
        LD HL,(FDDAD2)
        LD DE,(FDDTS)
        LD A,(FDDSEC)
        LD B,A
        JP FDDS2

FDDF    IN (#F8)
        LD A,#F4
        OUT (#1F),A
        LD A,(FDDTS+1)
        SRL A
        LD (FDDTTRK),A
        CCF
        LD A,0
        RRA
        LD (FDDTSID),A
FDDF1   LD D,(HL)
        INC HL
        LD E,(HL)
        INC HL
        LD A,D
        OR E
        INC A
        JR Z,FDDF6
        PUSH HL
        LD A,D
        LD (FDDTSEC),A
        LD A,E
        LD (FDDTSCL),A
        LD HL,FDDSLEN
        LD D,0
        ADD HL,DE
        LD E,(HL)
        INC HL
        LD D,(HL)
        LD (FDDF3+1),DE
        LD HL,FDDTF
FDDF2   LD D,0
        LD B,(HL)
        INC HL
        LD E,(HL)
        INC HL
        LD A,B
        INC A
        JR NZ,FDDF4
        LD A,E
        DEC A
        JR NZ,FDDF5
FDDF3   LD DE,0
        LD B,0
FDDF4   CALL FDDWF
        JR FDDF2
FDDF5   POP HL
        JR FDDF1
FDDF6   LD DE,#0200
        LD B,#4E
        CALL FDDWF





        RET

FDDE    LD HL,(FDDAD1)
        DEC C
        JP NZ,FDDS1
        LD C,3
        LD A,(FDDST+1)
        AND A
        JR Z,FDDE1
        LD C,1
        LD A,(FDDST)
        BIT 6,A
        JR NZ,FDDE1
        LD C,2
FDDE1   LD A,C
        LD (FDDERR),A
        RET

FDDRS   IN (#F8)
        PUSH BC
        LD A,E
        INC A
        OUT (#5F)
        LD A,#80
        OUT (#1F)
        CALL FDDRD
        IN (#F8)
        IN (#1F)
        LD C,A
        LD (FDDST),BC
        POP BC
        IN (#FA)
        RET

FDDWS   IN (#F8)
        PUSH BC
        LD A,E
        INC A
        OUT (#5F)
        LD A,#A0
        OUT (#1F)
        CALL FDDWD
        IN (#F8)
        IN (#1F)
        LD C,A
        LD (FDDST),BC
        POP BC
        IN (#FA)
        RET

FDDRD   IN (#F8)
        PUSH DE
        LD BC,#037F
FDDRD1  IN (#FF)
        AND #C0
        JR NZ,FDDRD2
        INC DE
        LD A,D
        OR E
        JR NZ,FDDRD1
        DJNZ FDDRD1
        JR FDDRD4
FDDRD2  INI
FDDRD3  IN (#FF)
        AND #C0
        JR Z,FDDRD3
        JP P,FDDRD2
FDDRD4  POP DE
        IN (#FA)
        RET

FDDWD   IN (#F8)
        PUSH DE
        LD BC,#037F
FDDWD1  IN (#FF)
        AND #C0
        JR NZ,FDDWD2
        INC DE
        LD A,D
        OR E
        JR NZ,FDDWD1
        DJNZ FDDWD1
        JR FDDWD4
FDDWD2  OUTI
FDDWD3  IN (#FF)
        AND #C0
        JR Z,FDDWD3
        JP P,FDDWD2
FDDWD4  POP DE
        IN (#FA)
        RET

FDDWF   IN (#F8)
        LD C,#7F
FDDWF1  IN (#FF)
        AND #C0
        JR Z,FDDWF1
        RET M
        OUT (C),B
        DEC DE
        LD A,D
        OR E
        JR NZ,FDDWF1
        IN (#FA)
        RET

RCMOS   PUSH DE,BC
        LD DE,#8000
        LD BC,#EFF7
        OUT D
        LD B,#DF
        OUT A
        LD B,#BF
        IN A
        LD B,#EF
        OUT E
        POP BC,DE
        RET

WCMOS   PUSH AF,BC
        LD BC,#EFF7
        LD A,#80
        OUT A
        LD B,#DF
        OUT D
        LD B,#BF
        OUT E
        LD B,#EF
        XOR A
        POP BC,AF
        RET

INKEY   PUSH IX,HL,DE,BC
        CALL KBD
        AND A
        JR Z,INKEY1
        LD HL,KBDLST
        CP (HL)
        JR Z,INKEY3
INKEY1  LD A,1
        DEC A
        LD (INKEY1+1),A
        JR NZ,INKEY4
        INC A
        LD (INKEY1+1),A
        CALL KBD
        LD (KBDLST),A
        AND A
        JR Z,INKEY4
INKEY2  LD A,(KBDDEL)
        LD (INKEY1+1),A
        LD A,(KBDREP)
        LD (INKEY3+1),A
        LD A,(KBDLST)
        JR INKEY5
INKEY3  LD A,1
        DEC A
        LD (INKEY3+1),A
        JR Z,INKEY2
INKEY4  XOR A
        LD (KBDLST),A
INKEY5  POP BC,DE,HL,IX
        RET

INSCC   PUSH HL,DE
        CALL SCC
        LD A,D
        CP #FF
        JR Z,INSCC1
        LD HL,SCCLST
        CP (HL)
        JR Z,INSCC3
INSCC1  LD A,1
        DEC A
        LD (INSCC1+1),A
        JR NZ,INSCC4
        INC A
        LD (INSCC1+1),A
        CALL SCC
        LD (SCCLST),DE
        LD A,D
        INC A
        JR Z,INSCC4
INSCC2  LD A,(KBDDEL)
        LD (INSCC1+1),A
        LD A,(KBDREP)
        LD (INSCC3+1),A
        LD A,(SCCLST)
        JR INSCC5
INSCC3  LD A,1
        DEC A
        LD (INSCC3+1),A
        JR Z,INSCC2
INSCC4  LD HL,#00FF
        LD (SCCLST),HL
INSCC5  POP DE,HL
        EI
        RET

KBD     CALL SCC
        LD A,(KBDREG)
        LD LX,A
        LD A,E
        CP #03
        JR NZ,KBD1
        LD A,#0E
        RET
KBD1    LD A,D
        INC A
        RET Z
        LD HL,KTAB1
        LD C,D
        LD B,0
        ADD HL,BC
        LD A,(HL)
        LD HX,A
        BIT 1,E
        JR Z,KBD2
        LD HL,KTAB2
        LD C,D
        LD B,0
        ADD HL,BC
        LD A,(HL)
        LD HX,A
        JR KBD5
KBD2    LD A,E
        XOR LX
        RRA
        JR NC,KBD3
        LD A,HX
        CP #61
        JR C,KBD3
        CP #7B
        JR NC,KBD3
        SUB #20
        LD HX,A
KBD3    BIT 0,E
        JR Z,KBD5
        LD HL,KTAB3
KBD4    LD A,(HL)
        INC HL
        CP #FF
        JR Z,KBD5
        CP HX
        LD A,(HL)
        INC HL
        JR NZ,KBD4
        RET
KBD5    LD D,LX
        BIT 1,D
        JR Z,KBD9
        LD HL,KTAB4
KBD6    LD A,(HL)
        INC HL
        CP #FF
        JR Z,KBD7
        CP HX
        LD A,(HL)
        INC HL
        JR NZ,KBD6
        LD D,LX
        BIT 0,D
        RET Z
        CP #ED
        JR Z,KBD8
        CP #EB
        RET NC
        CP #E7
        JR NC,KBD8
        RET
KBD7    LD A,HX
        RET
KBD8    SUB #50
        RET
KBD9    LD D,LX
        BIT 2,D
        JR Z,KBD7
        LD HL,KTAB5
KBD10   LD A,(HL)
        INC HL
        CP #FF
        JR Z,KBD7
        CP HX
        LD A,(HL)
        INC HL
        JR NZ,KBD10
        RET

SCC     PUSH HL,BC
        LD BC,#7FFE
        LD DE,#0005
SCC0    LD H,E
        IN L
SCC1    RR L
        JR NC,SCC3
SCC2    INC D
        DEC H
        JR NZ,SCC1
        RRC B
        LD A,D
        CP #28
        JR C,SCC0
        LD D,#FF
        JR SCC4
SCC3    LD A,D
        CP #23
        JR Z,SCC2
        DEC A
        JR Z,SCC2
SCC4    POP BC,HL
        LD E,0
        LD A,#7F
        IN (#FE)
.2      RRA
        JR C,SCC5
        SET 1,E
SCC5    LD A,#FE
        IN (#FE)
        RRA
        RET C
        SET 0,E
        RET

PRSYM   PUSH IX,HL,DE,BC
        LD BC,(PRXY)
        PUSH BC
        SRL C
        PUSH BC,AF
        LD A,B
        AND #18
        OR #40
        LD D,A,A,B
.3      RRCA
        AND #E0
        ADD A,C
        LD E,A
        POP AF
        LD BC,#F00F
        JR C,PRSYM1
        LD BC,#0FF0
PRSYM1  LD H,FONT[
        LD L,A
        LD A,(DE)
        AND B
        LD LX,A
        LD A,(HL)
        AND C
        OR LX
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LX,A
        LD A,(HL)
        AND C
        OR LX
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LX,A
        LD A,(HL)
        AND C
        OR LX
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LX,A
        LD A,(HL)
        AND C
        OR LX
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LX,A
        LD A,(HL)
        AND C
        OR LX
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LX,A
        LD A,(HL)
        AND C
        OR LX
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LX,A
        LD A,(HL)
        AND C
        OR LX
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LX,A
        LD A,(HL)
        AND C
        OR LX
        LD (DE),A
        POP BC
        LD L,B
        LD H,0
.5      ADD HL,HL
        LD B,#58
        ADD HL,BC
        LD A,(PRAT)
        LD (HL),A
        POP BC
        CALL PRINC
        LD (PRXY),BC
        POP BC,DE,HL,IX
        RET

PRATR   PUSH HL,BC
        LD BC,(PRXY)
        PUSH BC
        SRL C
        LD L,B
        LD H,0
.5      ADD HL,HL
        LD B,#58
        ADD HL,BC
        LD (HL),A
        POP BC
        CALL PRINC
        LD (PRXY),BC
        POP BC,HL
        RET

PRINC   INC C
        BIT 6,C
        RES 6,C
        RET Z
        INC B
        LD A,B
        CP #18
        RET C
        LD B,C
        RET

PRLS    LD A,(HL)
        INC HL
        CP #FF
        JR Z,PRLS1
        CALL PRSYM
        JR PRLS
PRLS1   LD A,(HL)
        INC HL
        AND A
        RET Z
        PUSH HL
        LD HL,PRLS
        EX (SP),HL
        DEC A
        JR Z,PRLS2
        DEC A
        JR Z,PRLS3
        DEC A
        JR Z,PRLS4
        RET
PRLS2   PUSH BC
        LD B,(HL)
        INC HL
        LD C,(HL)
        INC HL
        LD (PRXY),BC
        POP BC
        RET
PRLS3   LD A,(HL)
        INC HL
        LD (PRAT),A
        RET
PRLS4   XOR A
        LD (PRXY),A
        LD A,(PRXY+1)
        INC A
        CP #18
        JR C,PRLS5
        XOR A
PRLS5   LD (PRXY+1),A
        RET

PRLA    LD A,(HL)
        INC HL
        CP #FF
        JR Z,PRLA1
        CALL PRATR
        JR PRLA
PRLA1   LD A,(HL)
        INC HL
        AND A
        RET Z
        DEC A
        JR NZ,PRLA
        CALL PRLS2
        JR PRLA

SETXY   LD (PRXY),BC
        RET

SETAT   LD (PRAT),A
        RET



R00H    RET

R08H    RET

R10H    RET

R18H    RET

R20H    RET

R28H    RET

R30H    RET

R38H    EI
        RET

NMI     RETN

KTAB1   DB #20,0,"mnb"
        DB #0D,"lkjh"
        DB "poiuy"
        DB "09876"
        DB "12345"
        DB "qwert"
        DB "asdfg"
        DB 0,"zxcv"
KTAB2   DB #12,#03,".,*"
        DB #13,"=+-^"
        DB #22,";]["
        DB "_)('&"
        DB "!@#$%"
        DB #16,#14,#17,"<>"
        DB "~|\{}"
        DB #0E,":`?/"
KTAB3   DB "@0D112010300C31073206"
        DB "@330434053508360A370B"
        DB "@3809390FFF"
KTAB4   DB "ABCDEFGHIJKL"
        DB "MNOPQRSTUVWX"
        DB "YZ"
        DB "abcdefghijkl"
        DB "mnopqrstuvwx"
        DB "yz"
        DB "\{|}~",#FF
KTAB5   DB "1234567890"
        DB "ABCDEFGHIJKL"
        DB "MNOPQRSTUVWX"
        DB "YZ"
        DB "abcdefghijkl"
        DB "mnopqrstuvwx"
        DB "yz",#FF

FDDPR   DW FDDRES,FDDSET,FDDPOS,FDDR
        DW FDDW,FDDRET,FDDIGN,FDDF

FDDTF   DB "@4E50000CF603FC014E32000C"
        DB "@F503FE01"
FDDTTRK DB "@0001"
FDDTSID DB "@0001"
FDDTSEC DB "@0001"
FDDTSCL DB "@0001"
        DB "@F7014E16000CF503FB01FF01"
        DB "@F7014E32FF02"

FDDSLEN DW #0080,#0100,#0200,#0400

        ORG #3800,BEGIN+#3800
FONT    INCB "font64"